<?php


/**
 * A square is something like "h2".  It has a rank and a file.
 * 
 */
class Square {
  var $coord = "";
  
  /**
   * Set up the coord
   * 
   * @param string $coord e.g. "d4"
   */
  function set_coord($coord) {
    $this->coord = $coord;
  }
  
  /**
   * Get the rank (=row number), e.g. "4" for "d4"
   * 
   * @return string
   */
  function rank() {
    return $this->coord[1];    
  }
  
  /** 
   * Get the file (=column letter) e.g. "d" for "d4"
   */
  function get_file() {
    return $this->coord[0];
  }
  
  /**
   * Get the coord, e.g. "d4"
   */
  function coord() {
    return $this->coord;
  }
  
  /**
   * Convert coordinate [a1..h8] to 1dim index [0..63]
   *
   * a8=56, b8=57, c8=58, d8=59, e8=60, f8=61, g8=62, h8=63
   * a7=48, b7=49, c7=50, d7=51, e7=52, f7=53, g7=54, h7=55
   * a6=40, b6=41, c6=42, d6=43, e6=44, f6=45, g6=46, h6=47 
   * a5=32, b5=33, c5=34, d5=35, e5=36, f5=37, g5=38, h5=39
   * a4=24, b4=25, c4=26, d4=27, e4=28, f4=29, g4=30, h4=31
   * a3=16, b3=17, c3=18, d3=19, e3=20, f3=21, g3=22, h3=23 
   * a2=8,  b2=9,  c2=10, d2=11, e2=12, f2=13, g2=14, h2=15
   * a1=0,  b1=1,  c1=2,  d1=3,  e1=4,  f1=5,  g1=6,  h1=7
   * 
   */
  function convert2i() {
    $row = $this->coord[0];
    $col = $this->coord[1];
    switch ($row) {
      case 'a':
        $x = 0;
        break;
      case 'b':
        $x = 1;
        break;
      case 'c':
        $x = 2;
        break;
      case 'd':
        $x = 3;
        break;
      case 'e':
        $x = 4;
        break;
      case 'f':
        $x = 5;
        break;
      case 'g':
        $x = 6;
        break;
      case 'h':
        $x = 7;
        break;
      default:
        return 64; // error code 
    }
    $y = $col - 1;
    if ($y < 0 || $y > 7 ) {
      return 64; // error code 
    }
    $index = $y * 8 + $x;
    return $index;
  }
}